#ifndef _XC3S_Counter_H
#define _XC3S_Counter_H

#include "Prefix.h"
#include "XC3S_Register.h"

namespace EARTH {
namespace XC3S {
	class Register;

	class Counter {
	public:
		Counter(XC3S::Register *register_) : mRegister(register_)
		{
			_ASSERTE(mRegister);
		}

		~Counter()
		{
		}

		void GetPci(uint *count)
		{
			_ASSERTE(count);
			mRegister->Read4(A_PCI, count);
		}

		void GetError(uint index, uint *count)
		{
			uint gray;

			mRegister->Read4(A_ERROR+index, &gray);

			uint binary = 0;

			for (uint i=0; i<32; i++) {
				uint k = 0;
				for (uint j=i; j<32; j++) {
					k = k ^ BIT_SHIFT_MASK(gray, j, 1);
				}
				binary |= k << i;
			}

			_ASSERTE(count);
			*count = binary;
		}

	protected:
		enum {
			A_PCI   = 0x01,
			A_ERROR = 0x04
		};
		XC3S::Register	*const mRegister;
	};
}
}

#endif
