#ifndef _Memory__H
#define _Memory__H

#include "Memory.h"
#include <windows.h>

namespace EARTH {
namespace Memory {

	class Block;

	namespace _32 { Block *NewBlock(void *, uint, uint, uint); }
	namespace _64 { Block *NewBlock(void *, uint, uint, uint); }

	class __ : public _ {
	public:
		__(const argument *argument) : mDriver(argument->driver), mKernelBit(argument->kernelBit)
		{
		}

		virtual ~__()
		{
		}

		virtual Block *NewBlock(uint card, uint offset, uint size)
		{
			_ASSERTE(mDriver != INVALID_HANDLE_VALUE);
			_ASSERTE(size);

			Block *block;

			switch (mKernelBit) {
				case 32: block = _32::NewBlock(mDriver, card, offset, size); break;
				case 64: block = _64::NewBlock(mDriver, card, offset, size); break;
				default: block = NULL; _ASSERTE(false);                      break;
			}

			return block;
		}

	protected:
		void *const mDriver;
		uint mKernelBit;
	};
}
}

#endif
