#ifndef _Memory_Block_H
#define _Memory_Block_H

#include "Prefix_.h"

namespace EARTH {
namespace Memory {
	class Block {
	public:
		virtual ~Block() {}

		virtual void SetBasePtr(void *) = 0;

		virtual void *Ptr() const = 0;
		virtual uint Size() const = 0;

		enum Direction {
			DIRECTION_FROM_DEVICE = BIT_1(1) << 1,
			DIRECTION_TO_DEVICE   = BIT_1(1) << 2
		};

		virtual status Lock(Direction) = 0;
		virtual status Unlock() = 0;
		virtual bool IsLocked() const = 0;

		struct PhysicalAddressInfo {
			ulong PhysicalAddress;
			uint Size;
		};

		virtual void GetPhysicalAddress(uint *infoCount, const PhysicalAddressInfo **) const = 0;

		enum sync {
			SYNC_CPU,
			SYNC_IO
		};

		virtual bool Sync(sync) = 0;
	};
}
}

#endif
